package cviceni03;

import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;
import java.util.Map.Entry;


/*******************************************************************************
 * Trida ForEach slouzi k ...
 *
 * @author    jmeno autora
 * @author    Rudolf PECINOVSKY
 * @version   0.00.000,  0.0.2005
 */
public class ForEach
{ 
    public static double prumerPoleStary( double[] dd ) {
        double soucet = 0;
        for( int i=0;   i < dd.length;   i++ )
            soucet += dd[i];
        return soucet / dd.length;
    }

    public static double prumerPoleNovy( double[] dd ) {
        double soucet = 0;
        for( double d : dd )
            soucet += d;
        return soucet / dd.length;
    }

    public static void testPrumeruPole() {
        double[] polePokus = { 1, 3, 5, 7, 9 };
        System.out.println("Prumer postaru: " + prumerPoleStary( polePokus ));
        System.out.println("Prumer ponovu:  " + prumerPoleNovy ( polePokus ));
    }
   
    public static void tiskniMapuDrive( String titulek, Map mapa ) {
        System.out.println( titulek );
        for( Iterator it = mapa.entrySet().iterator();   it.hasNext();  ) {
            Entry entry = (Entry)it.next();
            System.out.println( "    " + entry.getKey() + 
                                " -- " + entry.getValue() );
        }
    }
        
    public static void tiskniMapuNyni( String titulek, Map mapa ) {
        System.out.println( titulek );
        for( Object polozka : mapa.entrySet() )
            System.out.println( "    " + ((Entry)polozka).getKey() +
                                " -- " + ((Entry)polozka).getValue() );
    }
    
    public static void testTiskuMapy() {
        Map m = new HashMap();
        m.put( "cesky",  "Dobry den" );
        m.put( "cesky",  "Nazdar" );
        m.put( "anglicky", "Hello" );
        m.put( "nemecky", "Guten Tag" );
        
        System.out.println("Anglicky se pozdravi: " + m.get("anglicky"));
        
        tiskniMapuDrive( "Drive - pozdravy:", m );
        tiskniMapuNyni ( "\nNyni - pozdravy:", m );
    }
    
  
//==============================================================================
     
    public static void odstranPrazdneStary( Collection c ) {
        //Predpokladam, ze se jedna o kolekci textovych retezcu
        for( Iterator it = c.iterator();   it.hasNext();   ) {
            String s = (String)it.next();
            if( (s == null)  ||  s.equals("") )
                it.remove();
        }
    }    
    
    public static void odstranPrazdneSpatny( Collection c ) {
        for( Object o : c ) {
            //Predpokladam, ze se jedna o kolekci textovych retezcu
            if( (o == null)  ||  ((String)o).equals("") )
                c.remove( o );
        }
    }
        
    public static void testRemove() {
        Collection col = Arrays.asList(
                                new String[] { "A", "", "C", null, "D" } );
        Collection col1;

        col.add("nazdar");

        col1 = new LinkedList( col );
//        col1.remove("A");
        System.out.println("Postaru - puvodni:  " + col1 );
        odstranPrazdneStary( col1 );
        System.out.println("Postaru - probrany: " + col1 );
        
//        col1 = new LinkedList( col );
//        System.out.println("Ponovu - puvodni:  " + col1 );
//        odstranPrazdneSpatny( col1 );
//        System.out.println("Ponovu - probrany: " + col1 );
    }
    
    public ForEach(){
    }
    
    public static void main( String... args )
    {
//        testPrumeruPole();
//        testTiskuMapy();
        testRemove();
    }
}
