package cviceni03;

import java.util.LinkedList;
import java.util.List;

public class FrontaTextuNova 
{
    //Seznam odkazu na instance String - tuto skutecnost je treba uvest
    //jak v typu seznamu, tak ve volani konstruktoru.
    List<String> nazvy = new LinkedList<String>();

    public void zarad( String nazev ) {
        //Pri vkladani odkazu na instanci spravneho typu 
        //se zdanlive nic nemeni - kontrola spravnosti totiz neni videt
        nazvy.add( nazev );
    }

//    public void zarad_1( Object objekt ) {
//        //Po udkomentovani zpusobi nasledujici prikaz syntaktickou chybu
//        //Podle deklarace lze do seznamu nazvy ukladat pouze instance String 
//        nazvy.add( objekt );
//    }

    public void zarad_2( Object objekt ) {
        //Chceme-li do seznamu nazvy ulozit odkaz deklarovany jako Object,
        //musime jej nejprve pretypovat na String, jinak jej prekladac neprijme
        nazvy.add( (String)objekt ); // KUBA: Co s tim?
    }

    public boolean isDalsi() {
        return (nazvy.size() > 0);
    }
    
    public String dalsi() {
        //Pri ziskavani odkazu z kontejneru jiz nemusime vracene odkazy
        //pretypovavat, to za nas udela prekladac.
        String ret = nazvy.get(0);
        nazvy.remove(0);
        return ret;
    }

//===== TESTY =================================================================

    public static void test() {
        FrontaTextuNova ftn = new FrontaTextuNova();
        for( String s : new String[] { "raz", "dva", "tri" } )
            ftn.zarad( s );
        ftn.zarad_2( ftn );
        
        System.out.println("Texty ve fronte: ");
        while( ftn.isDalsi() ) {
            System.out.println("   " + ftn.dalsi() );
        }
    }
    
    
    /***************************************************************************
     *
     */
    public static void main( String... args )
    {
        test();
    }
}
